<?php

require_once("./classes/class.motion.php");
$motion = new Motion();

if ($_POST) {
  header("Content-Type: text/plain");
  switch($_POST["action"]) {
    case "delete":
      if (@unlink(PHOTOS . "/" . $_POST["filename"])) {
        echo "ok";
      }
      break;
    case "getStatus":
      $tcam = $motion->checkCam() ? "true" : "false";
      $tmotion = $motion->checkMotion() ? "true" : "false";
      echo "cam=" . $tcam . "&motion=" . $tmotion;
      break;
    case "showFirst":
      $files = array();
      $dp = opendir(PHOTOS);
      while ($fn = readdir($dp)) {
        if (ereg("^[0-9]{14}-[0-9][0-9]\.jpg$", $fn)) {
          $files[] = $fn;
        }
      }
      closedir($dp);
      sort($files);
      echo $files[0];
      break;
    case "showLatest":
      $files= array();
      $dp = opendir(PHOTOS);
      while ($fn = readdir($dp)) {
        if (
          ereg("^[0-9]{14}-[0-9][0-9]\.jpg$", $fn)
        ) {
          $files[] = $fn;
        }
      }
      closedir($dp);
      if (count($files)) {
        sort($files);
        if (count($files) > 1) {
          echo "latest=" . $files[count($files) - 1] . "&hasPrev=true";
        } else {
          echo "latest=" . $files[0] . "&hasPrev=false";;
        }
      }
      break;
    case "showNext":
      if (! $_POST["filename"]) {
        exit;
      }
      $files = array();
      $dp = opendir(PHOTOS);
      while ($fn = readdir($dp)) {
        if (ereg("^[0-9]{14}-[0-9][0-9]\.jpg$", $fn)) {
          $files[] = $fn;
        }
      }
      closedir($dp);
      sort($files);
      $index = array_search($_POST["filename"], $files);
      if ($index + 1 < count($files)) {
        if ($index + 2 < count($files)) {
          echo "filename=" . $files[++$index] . "&hasNext=true";
        } else {
          echo "filename=" . $files[++$index] . "&hasNext=false";
        }
      }
      break;
    case "showPrev":
      if (! $_POST["filename"]) {
        exit;
      }
      $files = array();
      $dp = opendir(PHOTOS);
      while ($fn = readdir($dp)) {
        if (ereg("^[0-9]{14}-[0-9][0-9]\.jpg$", $fn)) {
          $files[] = $fn;
        }
      }
      closedir($dp);
      sort($files);
      $index = array_search($_POST["filename"], $files);
      if ($index - 1 >= 0) {
        if ($index - 2 >= 0) {
          echo "filename=" . $files[--$index] . "&hasPrev=true";
        } else {
          echo "filename=" . $files[--$index] . "&hasPrev=false";
        }
      }
      break;
    case "toggleMotion":
      if (! $motion->checkMotion()) {
        exec(STARTCMD);
        if (! $motion->checkMotion()) {
          echo "error";
        } else {
          echo "started";
        }
      } elseif ($motion->checkMotion()) {
        exec(KILLCMD);
        sleep(2);
        if ($motion->checkMotion()) {
          echo "error";
        } else {
          echo "stopped";
        }
      }
      break;
  }
  exit;
}

echo strtr(
  file_get_contents(TEMPLATES . "/index.thtml"),
  array(
    "[[[CAMERA]]]" => $motion->checkCam() ? "" : "NOT ",
    "[[[CAMERA_PNG]]]" => $motion->checkCam() ? "mount" : "unmount",
    "[[[MOTION]]]" => $motion->checkMotion() ? "" : "NOT ",
    "[[[MOTION_PNG]]]" => $motion->checkMotion() ? "on" : "off",
    "[[[STATUS]]]" =>
      $motion->checkCam() && $motion->checkMotion() ?
      "green" :
      "red"
    ,
    "[[[STOP_PLAY]]]" => $motion->checkMotion() ? "stop" : "play",
    "[[[STOP_START]]]" => $motion->checkMotion() ? "Stop" : "Start"
  )
);

?>
